(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     13354,        323]
NotebookOptionsPosition[     12897,        301]
NotebookOutlinePosition[     13254,        317]
CellTagsIndexPosition[     13211,        314]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"k", " ", "-", " ", 
     RowBox[{"length", " ", "of", " ", "illness"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"p", " ", "-", " ", 
     RowBox[{"probability", " ", "of", " ", "getting", " ", "sick"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"v", " ", "-", " ", 
     RowBox[{
     "probability", " ", "of", " ", "getting", " ", "vaccinated"}]}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"k", "=", "10"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p", " ", "=", " ", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmax", " ", "=", " ", "100"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "create", " ", "m", " ", "by", " ", "n", " ", "hospital", " ", "ward"}], 
     ",", " ", 
     RowBox[{
      RowBox[{"H", ".", " ", "\[IndentingNewLine]", "m"}], " ", "and", " ", 
      "n", " ", "must", " ", "be", " ", "even", " ", "numbers"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "50"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"H", " ", "=", " ", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"m", "+", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"determine", " ", "sick", " ", "person"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"H", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}], "/", "2"}], ",", "1"}], "]"}], 
      "]"}], "=", " ", "k"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"t", "=", "1"}], ",", 
     RowBox[{"t", "<", "tmax"}], ",", 
     RowBox[{"t", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"H", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", 
          RowBox[{"t", "+", "1"}]}], "]"}], "]"}], " ", "=", "  ", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"H", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "t"}], "]"}], "]"}], ">", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"H", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "t"}], "]"}], "]"}], "-", "1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"H", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "t"}], "]"}], "]"}], "\[Equal]", "1"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"-", "1"}], ",", " ", "\[IndentingNewLine]", 
             RowBox[{"H", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "t"}], "]"}], "]"}]}], "\[IndentingNewLine]",
             "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"m", "+", "2"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "2"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"m", "+", "1"}]}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RandomReal", "[", "]"}], "\[LessEqual]", "p"}], "&&", 
           RowBox[{
            RowBox[{"H", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", 
               RowBox[{"t", "+", "1"}]}], "]"}], "]"}], "\[Equal]", "0"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"anyNeighborSick", " ", "=", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"H", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"i", "-", "1"}], ",", "t"}], "]"}], "]"}], ">", 
               "0"}], "||", 
              RowBox[{
               RowBox[{"H", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"i", "+", "1"}], ",", "t"}], "]"}], "]"}], ">", 
               "0"}]}], ")"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"anyNeighborSick", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"H", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", 
                 RowBox[{"t", "+", "1"}]}], "]"}], "]"}], "=", "k"}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"ArrayPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"H", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"m", "+", "1"}]}], ",", "t"}], "]"}], "]"}], "}"}], ",", 
       RowBox[{"Mesh", "\[Rule]", "True"}], ",", 
       RowBox[{"ColorRules", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1"}], "\[Rule]", "Gray"}], ",", 
          RowBox[{"0", "\[Rule]", "White"}], ",", 
          RowBox[{"_", "\[Rule]", "Black"}]}], "}"}]}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "1", ",", "tmax", ",", "1"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.673892972173087*^9, 3.673893029370226*^9}, {
   3.674389685802906*^9, 3.67438995507205*^9}, {3.674390492374031*^9, 
   3.6743905168322268`*^9}, {3.6743907747136297`*^9, 3.674390776012298*^9}, {
   3.674390904248537*^9, 3.674390934288954*^9}, {3.674391232646659*^9, 
   3.674391241582692*^9}, {3.674391278755226*^9, 3.674391336620914*^9}, {
   3.674391455860668*^9, 3.674391523964594*^9}, {3.674391598085734*^9, 
   3.674391608756236*^9}, {3.674391738618417*^9, 3.674391740054111*^9}, {
   3.674391839476737*^9, 3.674391846247264*^9}, {3.6743919219245853`*^9, 
   3.6743919813071957`*^9}, 3.674392017549115*^9, {3.674392182290319*^9, 
   3.674392229467188*^9}, {3.674392279622671*^9, 3.674392391611966*^9}, {
   3.674393102509899*^9, 3.6743931606105957`*^9}, {3.674393549240947*^9, 
   3.674393625337124*^9}, {3.674394163322114*^9, 3.6743942163942432`*^9}, {
   3.674394324795985*^9, 3.67439432599266*^9}, {3.674394742302743*^9, 
   3.6743949157725363`*^9}, {3.674394951745964*^9, 3.6743950107096233`*^9}, {
   3.6743959420635033`*^9, 3.6743960654456244`*^9}, 3.674396195437166*^9, {
   3.674396391560656*^9, 3.67439642683118*^9}, {3.674396506696319*^9, 
   3.674396512217101*^9}, {3.674398046177291*^9, 3.6743980560224247`*^9}, {
   3.674398178615292*^9, 3.6743981791798773`*^9}, {3.674398434657877*^9, 
   3.674398472400881*^9}, {3.674398545057419*^9, 3.674398598861352*^9}, {
   3.6743986346346903`*^9, 3.674398729281775*^9}, {3.674398766024683*^9, 
   3.674398809886256*^9}, {3.674398866298978*^9, 3.674398867055332*^9}, 
   3.674398906952169*^9, {3.674398958027792*^9, 3.6743990131838303`*^9}, {
   3.674399679700123*^9, 3.674399709085471*^9}, {3.674399743157084*^9, 
   3.674399757435961*^9}, {3.6743998348485823`*^9, 3.674399893451042*^9}, {
   3.6743999453307962`*^9, 3.6743999796384697`*^9}, {3.674400114716976*^9, 
   3.6744001193981457`*^9}, {3.674400162776897*^9, 3.674400216745154*^9}, {
   3.674400249283329*^9, 3.6744002512166224`*^9}, {3.674400374169553*^9, 
   3.674400397744227*^9}, {3.674400430393277*^9, 3.67440054521588*^9}, {
   3.6744006413523684`*^9, 3.674400641641493*^9}, {3.674400677279092*^9, 
   3.6744006838334417`*^9}, {3.674400735249742*^9, 3.674400735983959*^9}, {
   3.674400783778859*^9, 3.6744007848273487`*^9}, {3.674400820250791*^9, 
   3.674400865546327*^9}, 3.674400925554529*^9, {3.674401132549975*^9, 
   3.674401200855651*^9}, {3.674401245673936*^9, 3.67440135005455*^9}, {
   3.674401386174135*^9, 3.6744013900960283`*^9}, {3.6744014508078957`*^9, 
   3.674401470098093*^9}, {3.6744020236518803`*^9, 3.674402024392411*^9}, {
   3.674402257948468*^9, 3.674402330135723*^9}, {3.674402377658395*^9, 
   3.674402398243546*^9}, {3.674402543504114*^9, 3.674402555513674*^9}, {
   3.674402591403615*^9, 3.6744025944731283`*^9}, {3.674402824116281*^9, 
   3.6744028703434668`*^9}, {3.674402981076199*^9, 3.674403020823708*^9}, {
   3.674403067539898*^9, 3.674403091647944*^9}, {3.6744033988778753`*^9, 
   3.674403408080429*^9}, {3.674403448749003*^9, 3.674403452121909*^9}, {
   3.674403736395507*^9, 3.674403757571867*^9}, {3.674403805132419*^9, 
   3.674403807273836*^9}, 3.674406728158374*^9, {3.674411886642338*^9, 
   3.674412037368936*^9}, {3.674412079517139*^9, 3.6744121416668587`*^9}, {
   3.674421352688774*^9, 3.674421382131606*^9}, {3.674421586558213*^9, 
   3.674421856853854*^9}, {3.6744218926250467`*^9, 3.674421897575181*^9}, {
   3.674421936541472*^9, 3.674421937517268*^9}, {3.674421974764008*^9, 
   3.674421978501359*^9}, {3.674422302541748*^9, 3.6744223192812653`*^9}, {
   3.6744226910708523`*^9, 3.674422705883213*^9}, {3.674422800377242*^9, 
   3.6744228711010447`*^9}, {3.674423082942226*^9, 3.674423117628582*^9}, {
   3.674423306857337*^9, 3.6744233168067417`*^9}, {3.6744233857088614`*^9, 
   3.674423397251359*^9}, {3.674423462837112*^9, 3.674423467468637*^9}, {
   3.674423879446762*^9, 3.674423892768162*^9}, {3.67442398366096*^9, 
   3.6744240829533987`*^9}, {3.6744246163496*^9, 3.6744246221928253`*^9}, 
   3.6744246697034388`*^9, {3.674428747665823*^9, 3.6744287683986073`*^9}, {
   3.674428874100156*^9, 3.674428889440997*^9}, {3.67442894078795*^9, 
   3.6744289423929367`*^9}, {3.674468281899356*^9, 3.6744682851274757`*^9}, {
   3.6745000974522133`*^9, 3.6745001680845203`*^9}, {3.674500209849515*^9, 
   3.674500242319109*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Sus", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"m", "+", "1"}]}], ",", "i"}], "]"}], "]"}], ",", "0"}], 
       "]"}], "/", "m"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rec", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"m", "+", "1"}]}], ",", "i"}], "]"}], "]"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "/", "m"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Inf", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"Sus", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "-", 
      RowBox[{"Rec", "[", 
       RowBox[{"[", "i", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Inf", ",", "Rec", ",", "Sus"}], "}"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"LineLegend", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Infected\>\"", ",", "\"\<Recovered\>\"", ",", 
       "\"\<Susceptible\>\""}], "}"}], "]"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Days\>\"", ",", "\"\<Proportion of Population\>\""}], 
     "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.674394453514097*^9, 3.674394455584874*^9}, {
  3.6744233761922007`*^9, 3.67442350172503*^9}, {3.674423637263557*^9, 
  3.674423674321864*^9}, {3.6744239049694767`*^9, 3.67442394487322*^9}, {
  3.6744240025989447`*^9, 3.6744240038846207`*^9}, {3.6744289100520487`*^9, 
  3.674428947685369*^9}, {3.674461044033647*^9, 3.674461072906763*^9}}]
},
WindowSize->{740, 567},
WindowMargins->{{94, Automatic}, {Automatic, 27}},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[400, 13, 10305, 221, 726, "Input"],
Cell[10708, 236, 2185, 63, 114, "Input"]
}
]
*)

