(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12926,        336]
NotebookOptionsPosition[     12627,        321]
NotebookOutlinePosition[     12985,        337]
CellTagsIndexPosition[     12942,        334]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"k", " ", "-", " ", 
     RowBox[{"length", " ", "of", " ", "illness"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"p", " ", "-", " ", 
     RowBox[{"probability", " ", "of", " ", "getting", " ", "sick"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"v", " ", "-", " ", 
     RowBox[{
     "probability", " ", "of", " ", "getting", " ", "vaccinated"}]}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"k", "=", "12"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p", " ", "=", " ", "0.1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmax", " ", "=", " ", "300"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "create", " ", "m", " ", "by", " ", "n", " ", "hospital", " ", "ward"}], 
     ",", " ", 
     RowBox[{
      RowBox[{"H", ".", " ", "\[IndentingNewLine]", "m"}], " ", "and", " ", 
      "n", " ", "must", " ", "be", " ", "even", " ", "numbers"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "50"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"n", "=", "50"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"H", " ", "=", " ", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"m", "+", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", 
         RowBox[{"n", "+", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"determine", " ", "sick", " ", "person"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"H", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}], "/", "2"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}], "/", "2"}], ",", "1"}], "]"}], 
      "]"}], "=", " ", "k"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"t", "=", "1"}], ",", 
     RowBox[{"t", "<", "tmax"}], ",", 
     RowBox[{"t", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"H", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"t", "+", "1"}]}], "]"}], "]"}], " ", "=", "  ", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"H", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j", ",", "t"}], "]"}], "]"}], ">", "1"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"H", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j", ",", "t"}], "]"}], "]"}], "-", "1"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"H", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "j", ",", "t"}], "]"}], "]"}], "\[Equal]", 
              "1"}], ",", "\[IndentingNewLine]", 
             RowBox[{"-", "1"}], ",", "\[IndentingNewLine]", 
             RowBox[{"H", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "j", ",", "t"}], "]"}], "]"}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"m", "+", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"n", "+", "2"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "2"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"m", "+", "1"}]}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "2"}], ",", 
           RowBox[{"j", "\[LessEqual]", 
            RowBox[{"n", "+", "1"}]}], ",", 
           RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RandomReal", "[", "]"}], "\[LessEqual]", "p"}], "&&", 
              
              RowBox[{
               RowBox[{"H", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "j", ",", 
                  RowBox[{"t", "+", "1"}]}], "]"}], "]"}], "\[Equal]", 
               "0"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"anyNeighborSick", " ", "=", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"H", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"i", "-", "1"}], ",", "j", ",", "t"}], "]"}], 
                   "]"}], ">", "0"}], "||", 
                 RowBox[{
                  RowBox[{"H", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "j", ",", "t"}], "]"}], 
                   "]"}], ">", "0"}], "||", 
                 RowBox[{
                  RowBox[{"H", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", 
                    RowBox[{"j", "-", "1"}], ",", "t"}], "]"}], "]"}], ">", 
                  "0"}], "||", 
                 RowBox[{
                  RowBox[{"H", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", 
                    RowBox[{"j", "+", "1"}], ",", "t"}], "]"}], "]"}], ">", 
                  "0"}]}], ")"}]}], ";", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{"anyNeighborSick", ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"H", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j", ",", 
                    RowBox[{"t", "+", "1"}]}], "]"}], "]"}], "=", "k"}]}], 
               "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
            "]"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"ArrayPlot", "[", 
      RowBox[{
       RowBox[{"H", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", 
           RowBox[{"m", "+", "1"}]}], ",", 
          RowBox[{"2", ";;", 
           RowBox[{"n", "+", "1"}]}], ",", "t"}], "]"}], "]"}], ",", 
       RowBox[{"Mesh", "\[Rule]", "True"}], ",", 
       RowBox[{"ColorRules", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1"}], "\[Rule]", "Gray"}], ",", 
          RowBox[{"0", "\[Rule]", "White"}], ",", 
          RowBox[{"_", "\[Rule]", "Black"}]}], "}"}]}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "1", ",", "tmax", ",", "1"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.674409103862466*^9, 3.6744091331125813`*^9}, 
   3.674409168156939*^9, {3.674409338934606*^9, 3.6744095951633253`*^9}, {
   3.674409638160177*^9, 3.67440968224886*^9}, {3.674409727435256*^9, 
   3.674409789971005*^9}, {3.674409945289053*^9, 3.6744099483079567`*^9}, {
   3.674410051021534*^9, 3.674410051365481*^9}, {3.6744101122625504`*^9, 
   3.674410158446644*^9}, {3.6744101896958027`*^9, 3.674410353951915*^9}, {
   3.6744104028245792`*^9, 3.674410439498143*^9}, {3.67441071735937*^9, 
   3.674410720434836*^9}, {3.67441079466179*^9, 3.6744108027359447`*^9}, {
   3.674411059972348*^9, 3.674411066451562*^9}, {3.674411400632352*^9, 
   3.6744114018022738`*^9}, {3.6744121942332993`*^9, 3.674412195085479*^9}, {
   3.674412239546493*^9, 3.674412240048027*^9}, {3.6744122702887173`*^9, 
   3.674412271639393*^9}, {3.674412343320492*^9, 3.674412372687697*^9}, {
   3.674412741389049*^9, 3.674412745279615*^9}, {3.6744131777562513`*^9, 
   3.674413197146411*^9}, {3.674413238620363*^9, 3.674413239550796*^9}, {
   3.6744132969502487`*^9, 3.6744132972787247`*^9}, {3.674413348622221*^9, 
   3.6744133630354958`*^9}, {3.674413396709622*^9, 3.6744133978096313`*^9}, {
   3.6744220248460093`*^9, 3.6744221182036343`*^9}, {3.6744221514892607`*^9, 
   3.674422176026465*^9}, {3.674422256616516*^9, 3.6744222610544367`*^9}, {
   3.674422422122571*^9, 3.6744224360382566`*^9}, {3.674422657828637*^9, 
   3.674422673368659*^9}, {3.67442942813214*^9, 3.674429438525029*^9}, {
   3.6744294794269114`*^9, 3.67442947982125*^9}, {3.674429517268079*^9, 
   3.674429519714848*^9}, {3.674461119182558*^9, 3.6744611232206717`*^9}, {
   3.674461167231419*^9, 3.674461171267333*^9}, {3.674461215696433*^9, 
   3.6744612388760757`*^9}, {3.674468594264018*^9, 3.674468597464415*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Sus", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"m", "+", "1"}]}], ",", 
           RowBox[{"2", ";;", 
            RowBox[{"n", "+", "1"}]}], ",", "i"}], "]"}], "]"}], ",", "0", 
        ",", 
        RowBox[{"m", "+", "2"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"m", "*", "n"}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rec", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{"H", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"m", "+", "1"}]}], ",", 
           RowBox[{"2", ";;", 
            RowBox[{"n", "+", "1"}]}], ",", "i"}], "]"}], "]"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"m", "+", "2"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"m", "*", "n"}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Inf", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"Sus", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "-", 
      RowBox[{"Rec", "[", 
       RowBox[{"[", "i", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "tmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Inf", ",", "Rec", ",", "Sus"}], "}"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"LineLegend", "[", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Infected\>\"", ",", "\"\<Recovered\>\"", ",", 
       "\"\<Susceptible\>\""}], "}"}], "]"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Days\>\"", ",", "\"\<Proportion of Population\>\""}], 
     "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.674394453514097*^9, 3.674394455584874*^9}, {
   3.6744233761922007`*^9, 3.67442350172503*^9}, {3.674423637263557*^9, 
   3.674423674321864*^9}, {3.6744239049694767`*^9, 3.67442394487322*^9}, {
   3.6744240025989447`*^9, 3.6744240038846207`*^9}, {3.6744289100520487`*^9, 
   3.674428947685369*^9}, {3.674429092453227*^9, 3.6744291117448463`*^9}, {
   3.674429161345467*^9, 3.674429162000258*^9}, 3.674429301276063*^9, {
   3.674429345739265*^9, 3.674429422632078*^9}, {3.674460351564582*^9, 
   3.674460441367682*^9}, {3.674460500390543*^9, 3.674460525495071*^9}, {
   3.674460696912189*^9, 3.674460706168655*^9}, {3.6744607880037746`*^9, 
   3.6744608426349077`*^9}, {3.674460991182247*^9, 3.674461020621942*^9}}]
},
WindowSize->{740, 567},
WindowMargins->{{Automatic, 308}, {Automatic, 27}},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 9163, 219, 777, "Input"],
Cell[9723, 241, 2900, 78, 114, "Input"]
}
]
*)

(* End of internal cache information *)
